<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Transforms;

function getter($property)
{
    return method('get'.ucfirst($property));
}

function property($property)
{
    return function ($object) use ($property) {
        if (method_exists($object, $getter = 'get'.ucfirst($property))) {
            return $object->{$getter}();
        }

        return $object->{$property};
    };
}

function field($field)
{
    return function ($object) use ($field) {
        return $object->{$field};
    };
}

function method($method, ...$args)
{
    return function ($object) use ($method, $args) {
        return $object->{$method}(...$args);
    };
}